class AdImage
  include Mongoid::Document
  include Mongoid::Timestamps

  mount_uploader :file, ImageUploader

  has_one :title, :class_name => "I18nVariable", :as => :language_value, :autosave => true, :dependent => :destroy
  has_one :context, :class_name => "I18nVariable", :as => :language_value, :autosave => true, :dependent => :destroy
  
  field :direct_to_after_click,type: Boolean
  
  field :weight ,type: Integer ,default: 1
  field :out_link #the link itself
  field :link_open #how will the link be opened
  LINK_OPEN_TYPES = ["new_window","local"]
  
  field :post_date,type: Date
  field :unpost_date,type: Date
  
  field :to_save, :type => Boolean
  field :to_destroy, :type => Boolean
    
  belongs_to :ad_banner

  # validates_numericality_of :weight, greater_than_or_equal_to: 1,less_than_or_equal_to: 10
  # validates_format_of :out_link, with: /(http:\/\/.*|)/ ,:message => 'Need a valid URL'
  attr_reader :parse_post_date,:parse_unpost_date

  def parse_post_date=(att)
    self.post_date = (Date.parse att.gsub(/\s+/, "") rescue nil)
  end
  
  
  def parse_unpost_date=(att)
    self.unpost_date = (Date.parse att.gsub(/\s+/, "") rescue nil)
  end

  def display?
    if (self.post_date <= Date.today && (self.unpost_date.nil? || self.unpost_date>= Date.today) rescue false) 
      return true
    end
      return false
  end


  def get_delay_time
    time = ''
    if self.time_to_next.nil?
      time = '1000'
    else
      time = (self.time_to_next.to_i * 1000).to_s
    end
    time
  end
end
